﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Zorbo;

using Jurassic;
using Jurassic.Library;

using JScript = Javascript.Script;

namespace Javascript.Objects
{
    public class UTF16 : Encoding
    {
        JScript script;

        #region " Constructor "

        public new class Constructor : ClrFunction
        {
            JScript script;

            public Constructor(JScript script)
                : base(script.Engine.Function.InstancePrototype, "UTF16", new UTF16(script)) {

                this.script = script;
            }

            [JSCallFunction]
            public Encoding Call() { return new UTF16(script); }

            [JSConstructorFunction]
            public Encoding Construct() { return new UTF16(script); }
        }

        #endregion


        public UTF16(JScript script)
            : base(script, System.Text.Encoding.Unicode) {

            this.script = script;
            this.PopulateFunctions();
        }

        protected override string InternalClassName {
            get { return "UTF16"; }
        }
    }
}
