﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Zorbo;
using Zorbo.Interface;

using Jurassic;
using Jurassic.Library;

using JScript = Javascript.Script;

namespace Javascript.Objects
{
    public class Error : ObjectInstance
    {
        JScript script = null;
        JavaScriptException error = null;

        protected override string InternalClassName {
            get { return "Error"; }
        }

        public Error(JScript script, JavaScriptException ex)
            : base(script.Engine) {

            this.error = ex;
            this.script = script;

            this.PopulateFields();
            this.PopulateFunctions();
        }

        [JSProperty(Name = "line")]
        public int Line {
            get { return error.LineNumber; }
        }

        [JSProperty(Name = "script")]
        public string Script {
            get { return script.Name; }
        }

        [JSProperty(Name = "source")]
        public string Source {
            get { return error.Source; }
        }

        [JSProperty(Name = "trace")]
        public string StackTrace {
            get { return error.StackTrace; }
        }

        [JSProperty(Name = "message")]
        public string Message {
            get { return error.Message; }
        }
    }
}
