﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Zorbo.Interface
{
    public interface IBanned : IReadOnlyList<IClientId>
    {
        bool Add(IClient client);
        bool Add(IRecord record);
        bool Add(IClientId banned);

        bool Remove(IClient client);
        bool Remove(IRecord record);
        bool Remove(IClientId banned);
        bool Remove(Predicate<IClientId> search);
        bool RemoveAt(Int32 index);
        void RemoveAll(Predicate<IClientId> search);

        void Clear();
    }
}
