﻿using System;
using System.IO;
using System.Linq;
using System.Text;
using System.Globalization;
using System.Collections.Generic;
using System.Windows.Data;
using System.Windows.Media.Imaging;

namespace Zorbo.UI
{
    public class AvatarToSourceConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, CultureInfo culture) {

            if (value is AresAvatar) {

                byte[] bytes = ((AresAvatar)value).LargeBytes;

                if (bytes.Length > 0) {

                    BitmapImage img = new BitmapImage();
                    MemoryStream stream = new MemoryStream(bytes);

                    img.BeginInit();
                    img.StreamSource = stream;
                    img.EndInit();

                    img.Freeze();
                    return img;
                }
            }

            return null;
        }

        public object ConvertBack(object value, Type targetType, object parameter, CultureInfo culture) {
            return null;
        }
    }
}
