﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Zorbo.Interface;
using Zorbo.Serialization;
using Zorbo.Packets;

namespace cb0tProtocol.Packets
{
    class ServerFont : AresPacket
    {
        string name = "Verdana";
        byte size = 11;
        byte namecolor = 255;
        byte textcolor = 255;

        public override byte Id {
            get { return (byte)AdvancedId.MSG_CHAT_SERVER_CUSTOM_FONT; }
        }

        [PacketItem(0)]
        public string Username { get; set; }

        [PacketItem(1)]
        public byte Size {
            get { return size; }
            set { size = value; }
        }

        [PacketItem(2)]
        public String Name {
            get { return name; }
            set { name = value; }
        }

        [PacketItem(3, Optional = true, OptionalValue = (byte)255)]
        public byte NameColor {
            get { return namecolor; }
            set { namecolor = value; }
        }

        [PacketItem(4, Optional = true, OptionalValue = (byte)255)]
        public byte TextColor {
            get { return textcolor; }
            set { textcolor = value; }
        }

        public ServerFont() { }

        public ServerFont(IClient user) {
            Username = user.Name;
        }
    }
}
